<?php
/*
Copyright 2005 Nils Reimers (www.php-einfach.de

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

mt_srand(crc32(microtime()));
function removeKommentare($str) {
   $i = 0;
	while($i < strlen($str))
	{

		$char = $str{$i};

		if($char == '"')
		{
			$i = gotoNext($str, '"', ($i+1));
			continue;
		}
		else if($char == "'")
		{
      	$i = gotoNext($str, "'", ($i+1));
			continue;
		}
		else if($char == "#") // #-Kommentare
		{
			$end = gotoNext($str, "\n", ($i+1));
			$str = substr($str, 0, $i-1).substr($str, $end);

		}
      else if($char == "/" && $str{$i+1} == "/") // //Kommentare
		{
			$end = gotoNext($str, "\n", ($i+1));
			$str = substr($str, 0, $i-1).substr($str, $end);
		}
		else if($char == "/" && $str{$i+1} == "*") // /* Kommentare
		{
			$end = $i+1;

			while(strlen($str{$i}) != 0 && $str{$end} != "/")
         	$end = gotoNext($str, "*", $end);

			$str = substr($str, 0, $i-1).substr($str, $end+1);
		}

		$i++;
	}

	return $str;
}



function replaceVariablen($str)
{
	global $varNames;
	$varNames = array();
	$i = 0;

	//'...' per base64-kodieren

	$str = preg_replace_callback("/(\")(.*?)\"/si","base64_encode_string",$str);
   $str = preg_replace_callback("/(')(.*?)'/si","base64_encode_string",$str);
	$str = preg_replace_callback("/(\")(.*?)\"/si","base64_decode_string",$str);

	//$erg = preg_match('/\\$([a-zA-Z_\x7f-\xff][a-zA-Z0-9_\x7f-\xff]*)/si', $str, $treffer, PREG_OFFSET_CAPTURE);
   preg_replace_callback('/\\$([a-zA-Z_\x7f-\xff][a-zA-Z0-9_\x7f-\xff]*)/si', "variable", $str);

	krsort($varNames);

   foreach($varNames AS $key=>$name)
		$str = str_replace('$'.$key, '$'.$name, $str);



	//'...' dekodieren
	$str = preg_replace_callback("/(\")(.*?)\"/si","base64_encode_string",$str);
	$str = preg_replace_callback("/(')(.*?)'/si","base64_decode_string",$str);
	$str = preg_replace_callback("/(\")(.*?)\"/si","base64_decode_string",$str);

	return $str;
}

function replaceFunction($str)
{
	global $funcNames;
	$funcNames = array();

	$str = preg_replace_callback("/(\")(.*?)\"/si","base64_encode_string",$str);
   $str = preg_replace_callback("/(')(.*?)'/si","base64_encode_string",$str);

   preg_replace_callback('/function ([a-zA-Z_][a-zA-Z0-9_-]*)/si', "functionName", $str);



	krsort($funcNames);

   foreach($funcNames AS $key=>$name)
	{
		$str = str_replace('function '.$key, 'function '.$name, $str);
		$str = preg_replace("/".$key."[ ]*\(/si", "$name(", $str);
	}

   $str = preg_replace_callback("/(')(.*?)'/si","base64_decode_string",$str);
	$str = preg_replace_callback("/(\")(.*?)\"/si","base64_decode_string",$str);

	return $str;
}

function removeWhitespaces($str)
{
	$sprachkonstrukte = array();
   $sprachkonstrukte[] = "function";
	$sprachkonstrukte[] = "echo";
	$sprachkonstrukte[] = "class";
	$sprachkonstrukte[] = "private";
	$sprachkonstrukte[] = "protected";
	$sprachkonstrukte[] = "public";
	$sprachkonstrukte[] = "var";
	$sprachkonstrukte[] = "throw";
	$sprachkonstrukte[] = "new";
	$sprachkonstrukte[] = "return";

	$str = preg_replace_callback("/(\")(.*?)\"/si","base64_encode_string",$str);
   $str = preg_replace_callback("/(')(.*?)'/si","base64_encode_string",$str);

	//Leerzeichen
   $str = preg_replace('/([ ]{2,})/si', " ", $str);
   $str = preg_replace('/[ ]*([=.,<>!+;*\/(){}-]+)[ ]*/si', "\\1", $str);


	$str = str_replace("\r", "", $str);
	$str = str_replace("\n", "", $str);
	$str = str_replace("<?php", "<?php ", $str);



   $str = preg_replace_callback("/(')(.*?)'/si","base64_decode_string",$str);
	$str = preg_replace_callback("/(\")(.*?)\"/si","base64_decode_string",$str);

	return $str;
}

function kodieren($str, $times=24) {
	$str = base64_encode(gzdeflate('?>'.$str));
	for($i=0;$i<$times;$i++) {
		$str = base64_encode(gzdeflate('eval(gzinflate(base64_decode("'.$str.'")));'));
	}

	return '<?php eval(gzinflate(base64_decode("'.$str.'"))); ?>';
}

function base64_encode_string($arg) {
   return $arg[1].base64_encode($arg[2]).$arg[1];
}

function base64_decode_string($arg) {
   return $arg[1].base64_decode($arg[2]).$arg[1];
}

function variable($arg)
{
	global $varNames;
   $reservierteVariablen = array("_GET", "_POST", "_SESSION", "_COOKIE", "GLOBALS", "_SERVER", "_FILES", "_ENV", "_REQUEST", "this");


	if(!in_array($arg[1], $reservierteVariablen) && $varNames[$arg[1]] == null)
      $varNames[$arg[1]] = nextVarName();
}

function functionName($arg) {
   global $funcNames;



	if($funcNames[$arg[1]] == null)
		$funcNames[$arg[1]] = nextFuncName();

}


$usedVarNames = null;
function nextVarName() {
	global $usedVarNames;


	if($usedVarNames == null)
		$rand = randStr(12);
	else
	{
		$rand = key($usedVarNames);
		$buchstaben = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
		$buchstaben_lng = strlen($buchstaben)-1;


		do {
			$pos = mt_rand(0, strlen($rand)-1);
			$rand{$pos} = $buchstaben{ mt_rand(0, ($buchstaben_lng - (($pos > 0) ? 0 : 10)) )};
		} while($usedVarNames[$rand] != null);

	}

	$usedVarNames[$rand] = true;


	return $rand;
}


$usedFuncNames = null;
function nextFuncName() {
	global $usedFuncNames;


	if($usedFuncNames == null)
		$rand = randStr(12);
	else
	{
		$rand = key($usedFuncNames);
		$buchstaben = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
		$buchstaben_lng = strlen($buchstaben)-1;


		do {
			$pos = mt_rand(0, strlen($rand)-1);
			$rand{$pos} = $buchstaben{ mt_rand(0, ($buchstaben_lng - (($pos > 0) ? 0 : 10)) )};
		} while($usedFuncNames[$rand] != null);

	}

	$usedFuncNames[$rand] = true;


	return $rand;
}

function randStr($lng) {

   //Welche Buchstaben benutzt werden sollen (Charset)
   $buchstaben = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";

   $str_lng = strlen($buchstaben)-1;
   $rand = $buchstaben{mt_rand(0, ($str_lng-10))};

   for($i=1;$i<$lng;$i++)
      $rand.= $buchstaben{mt_rand(0, $str_lng)};

	return $rand;
}




function gotoNext($str, $sign, $offset) {

	while(strlen($str{$offset}) != 0)
	{
   	$char = $str{$offset};

		if($char == "\\")
			$offset++;
		else if($char == $sign)
			return $offset+1;
		$offset++;
	}
}

?>